<template>
  <PlaceholderPage
    v-if="!municipality"
    text="Выберите муниципальное образование и адрес"
  />
  <div v-else>
    <div :class="$style.title">Технические характеристики системы</div>
    <div class="custom-row">
      <div class="custom-col-1">
        <CustomSelect
          class="mb-6"
          label="Тип системы"
          type="variant-2"
          :options="filter.getVentilationSystemsTypes"
          v-model="values.systemType"
        />
      </div>
      <div class="custom-col-1">
        <CustomInput
          class="mb-6"
          label="Количество дымоходов в МКД (всего), ед."
          placeholder="Ввести"
          tooltip="Подсказка"
          type="number"
          v-model="values.houseChimneysCount"
        />
        <CustomInput
          class="mb-6"
          label="Количество вентканалов в МКД (всего), ед."
          placeholder="Ввести"
          tooltip="Подсказка"
          v-model="values.houseVentilationChannelsCount"
        />
      </div>
      <div class="custom-col-1">
        <CustomInput
          class="mb-6"
          label="Длина дымоходов, м.п."
          placeholder="Ввести"
          tooltip="Подсказка"
          v-model="values.houseChimneysLength"
        />
        <CustomInput
          class="mb-6"
          label="Длина вентканалов, м.п."
          placeholder="Ввести"
          tooltip="Подсказка"
          v-model="values.houseVentilationChannelsLength"
        />
      </div>
      <div class="custom-col-2">
        <div class="custom-row justify-center">
          <div class="custom-col-2">
            <CustomInput
              class="mb-6"
              label="Приточный клапан дымохода"
              placeholder="Ввести"
              tooltip="Подсказка"
              v-model="values.house_chimneys_cap_size"
            />
            <CustomInput
              class="mb-6"
              label="Приточный клапан вентканала"
              placeholder="Ввести"
              tooltip="Подсказка"
              v-model="values.house_ventilation_channels_dimensions"
            />
          </div>
          <div class="custom-col-2">
            <div class="mx-auto">
              <CustomSelect
                class="mb-6"
                label="Боров"
                :options="filter.valve"
                v-model="values.house_chimneys_has_valve"
              />
              <CustomSelect
                class="mb-6"
                label="Боров"
                :options="filter.yesOrNo"
                v-model="values.house_has_cojoined_chimneys_ventilation"
              />
            </div>
          </div>
        </div>
      </div>
    </div>
    <div class="custom-row mb-12">
      <div class="custom-col-1">
        <CustomInput
          class="mb-6"
          label="Год постройки"
          placeholder="Ввести"
          tooltip="Подсказка"
          v-model="values.houseBuildYear"
        />
      </div>
      <div class="custom-col-1">
        <CustomInput
          class="mb-6"
          label="Общая площадь дома, тыс.кв.м."
          placeholder="Ввести"
          tooltip="Подсказка"
          v-model="values.houseSquare"
        />
      </div>
      <div class="custom-col-1">
        <CustomInput
          class="mb-6"
          label="Кол-во этажей, ед."
          placeholder="Ввести"
          tooltip="Подсказка"
          v-model="values.houseFloors"
        />
      </div>
      <div class="custom-col-1">
        <CustomInput
          class="mb-6"
          label="Кол-во подъездов, ед."
          placeholder="Ввести"
          tooltip="Подсказка"
          v-model="values.houseEntrances"
        />
      </div>
      <div class="custom-col-1">
        <CustomInput
          class="mb-6"
          label="Количество квартир, ед."
          placeholder="Ввести"
          tooltip="Подсказка"
          v-model="values.houseFlats"
        />
      </div>
      <div class="custom-col-1">
        <CustomSelect
          class="mb-6"
          label="Наличие борова"
          :options="filter.yesOrNo"
          v-model="values.house_has_flue"
        />
      </div>
    </div>
    <div :class="$style.title">
      Проверка состояния акт по форме Ф-20 с Газ
      <v-tooltip top>
        <template v-slot:activator="{ on, attrs }">
          <v-icon
            dense
            :class="$style.icon"
            v-bind="attrs"
            v-on="on"
          >
            mdi-help-circle
          </v-icon>
        </template>
        <span>Подсказка</span>
      </v-tooltip>
    </div>
    <div class="custom-row mb-12">
      <div class="custom-col-1">
        <CustomInput
          class="mb-6"
          label="Форма Ф-20 с Газ"
          placeholder="Ввести"
          type="date"
          v-model="values.house20cFormDate"
        />
      </div>
      <div class="custom-col-1">
        <CustomInput
          label="Заключение"
          placeholder="Ввести"
          v-model="values.house20cFormConclusion"
        />
      </div>
      <div class="custom-col-3">
        <CustomTextarea
          label="Причина отключения"
          placeholder="Ввести"
          rows="1"
          v-model="values.house20cFormShutdownReason"
        />
      </div>
      <div class="custom-col-1">
        <CustomInput
          label="Дата отключения газоснабжения"
          placeholder="Ввести"
          type="date"
          v-model="values.houseGasShutdownDate"
        />
      </div>
      <div class="custom-col-1">
        <CustomInput
          label="Отключено квартир, шт."
          placeholder="Ввести"
          v-model="values.houseGasShutdownAffectedFlatsCount"
        />
      </div>
      <div class="custom-col-1">
        <CustomInput
          label="Дата восстановления газоснабжения"
          placeholder="Ввести"
          v-model="values.houseGasShutdownResumeDate"
        />
      </div>
      <div class="custom-col-1">
        <CustomInput
          label="Возобновлено, квартир шт."
          placeholder="Ввести"
          v-model="values.houseGasShutdownResumeAffectedFlatsCount"
        />
      </div>
      <div class="custom-col-1">
        <CustomInput
          label="Процент износа систем"
          placeholder="1-100%"
          tooltip="Подсказка"
          v-model="values.houseDeteriorationPercentage"
        />
      </div>
    </div>
    <div :class="$style.title">
      Обследование систем
    </div>
    <div class="custom-row mb-12">
      <div class="custom-col-1">
        <CustomInput
          label="Наименование организации"
          placeholder="Ввести"
          v-model="values.checkupContractorName"
        />
      </div>
      <div class="custom-col-1">
        <CustomInput
          label="Номер договора"
          placeholder="Ввести"
          v-model="values.checkupContractorContractNumber"
        />
      </div>
      <div class="custom-col-1">
        <CustomInput
          label="Дата договора"
          placeholder="Ввести"
          type="date"
          v-model="values.checkupContractorContractDate"
        />
      </div>
      <div class="custom-col-1">
        <CustomSelect
          label="Результат обследования, требуется"
          type="variant-2"
          :options="filter.getVentilationRepairsTypes"
          v-model="values.checkupResult"
        />
      </div>
      <div class="custom-col-1">
        <InputFile
          title="Акт обследования"
          value=""
        />
      </div>
    </div>
    <div :class="$style.title">
      Осмечивание работ
    </div>
    <div class="custom-row mb-12">
      <div class="custom-col-1">
        <CustomInput
          label="Наименование организации"
          placeholder="Ввести"
          v-model="values.costEstimatingContractorName"
        />
      </div>
      <div class="custom-col-1">
        <CustomInput
          label="Номер договора"
          placeholder="Ввести"
          v-model="values.checkupContractorContractNumber"
        />
      </div>
      <div class="custom-col-1">
        <CustomInput
          label="Дата договора"
          placeholder="Ввести"
          v-model="values.checkupContractorContractDate"
        />
      </div>
      <div class="custom-col-1">
        <CustomInput
          label="Сумма затрат, руб."
          placeholder="Ввести"
          v-model="values.costEstimatingCost"
        />
      </div>
      <div class="custom-col-1">
        <InputFile
          title="Смета"
          value=""
        />
      </div>
    </div>
    <div :class="$style.title">
      Проведённые работы
    </div>
    <div class="custom-row mb-12">
      <div class="custom-col-1">
        <CustomInput
          label="Наименование организации"
          placeholder="Ввести"
          v-model="values.repairsContractorName"
        />
      </div>
      <div class="custom-col-1">
        <CustomInput
          label="Номер договора"
          placeholder="Ввести"
          v-model="values.repairsContractNumber"
        />
      </div>
      <div class="custom-col-1">
        <CustomInput
          label="Дата договора"
          placeholder="Ввести"
          v-model="values.repairsContractDate"
        />
      </div>
      <div class="custom-col-1">
        <CustomInput
          label="Сумма затрат, руб."
          placeholder="Ввести"
          v-model="values.repairsCost"
        />
      </div>
      <div class="custom-col-1">
        <CustomInput
          label="Дата проведения"
          placeholder="Ввести"
          type="date"
          v-model="values.repairsPeriod"
        />
      </div>
      <div class="custom-col-1">
        <CustomSelect
          label="Вид проведённых работ"
          type="variant-2"
          :options="filter.getVentilationRepairsTypes"
          v-model="values.ventilationRepairTypeId"
        />
      </div>
      <div class="custom-col-1">
        <CustomInput
          label="Количество отремонтированных систем"
          placeholder="Ввести"
          v-model="values.ventilationRepairedSystemsCount"
        />
      </div>
      <div class="custom-col-1">
        <InputFile
          title="Акт выполненных работ, КС-2"
          value=""
        />
      </div>
      <div class="custom-col-3">
        <CustomTextarea
          label="Примечание"
          placeholder="Ввести"
          v-model="values.note"
        />
      </div>
    </div>
    <CustomButton
      type="default"
      :class="[$style.inputButton, 'mr-4']"
      @click="handleUpdateVentilation"
    >
      Сохранить изменения
    </CustomButton>
  </div>
</template>

<script>
import moment from "moment";
import PlaceholderPage from "@/components/Overhaul/PlaceholderPage";
import CustomInput from "@/components/CustomInput";
import CustomSelect from "@/components/CustomSelect";
import CustomButton from "@/components/CustomButton";
import CustomTextarea from "@/components/CustomTextarea";
import InputFile from "@/components/InputFile";
import { DEFAULT_VALUES_VENTILATION_INPUT } from "@/constants/variables";

export default {
  name: "VentilationInput",
  components: {
    PlaceholderPage,
    InputFile,
    CustomInput,
    CustomSelect,
    CustomButton,
    CustomTextarea,
  },
  props: {
    municipality: {
      type: String,
      default: "",
    },
  },
  apollo: {
    getVentilation: {
      query: require('@/graphql/getVentilation.gql'),
      fetchPolicy: 'network-only',
      skip() {
        return !this.municipality;
      },
      variables() {
        return {
          houseAddress: this.municipality,
        }
      },
      result(response) {
        this.ventilationId = response?.data?.getVentilation?.id || null;
        this.filter.getVentilationSystemsTypes = response?.data?.getVentilationSystemsTypes?.map(item => ({
          label: item?.title,
          value: item?.id,
        }));
        this.filter.getVentilationRepairsTypes = response?.data?.getVentilationRepairsTypes?.map(item => ({
          label: item?.title,
          value: item?.id,
        }));
        this.setValues(response?.data?.getVentilation || {});
      },
    },
  },
  data() {
    return {
      filter: {
        getVentilationSystemsTypes: [],
        getVentilationRepairsTypes: [],
        valve: [
          { label: 'Есть', value: true },
          { label: 'Нет', value: false },
        ],
        yesOrNo: [
          { label: 'Да', value: true },
          { label: 'Нет', value: false },
        ],
      },
      ventilationId: null,
      values: DEFAULT_VALUES_VENTILATION_INPUT,
    };
  },
  methods: {
    convertDateToInput(date) {
      return moment(date).isValid()
        ? moment(date).format('YYYY-MM-DD')
        : '';
    },
    setValues(values = {}) {
      this.values = {
        systemType: undefined,
        houseChimneysCount: values.house_chimneys_count,
        houseChimneysLength: values.house_chimneys_length,
        houseVentilationChannelsCount: values.house_ventilation_channels_count,
        houseVentilationChannelsLength: values.house_ventilation_channels_length,
        houseBuildYear: values.house_build_year,
        houseSquare: values.house_square,
        houseFloors: values.house_floors,
        houseEntrances: values.house_entrances,
        houseFlats: values.house_flats,

        house20cFormDate: this.convertDateToInput((values?.house_20c_form_date)),
        house20cFormConclusion: values.house_20c_form_conclusion,
        house20cFormShutdownReason: undefined,
        houseGasShutdownDate: this.convertDateToInput((values?.house_gas_shutdown_date)),
        houseGasShutdownAffectedFlatsCount: values.house_gas_shutdown_affected_flats_count,
        houseGasShutdownResumeDate: values.house_gas_shutdown_resume_date,
        houseGasShutdownResumeAffectedFlatsCount: values.house_gas_shutdown_resume_affected_flats_count,
        houseDeteriorationPercentage: undefined,

        checkupContractorName: undefined,
        checkupContractorContractNumber: undefined,
        checkupContractorContractDate: undefined,
        checkupResult: undefined,

        costEstimatingContractorName: undefined,
        costEstimatingContractNumber: undefined,
        costEstimatingContractDate: undefined,
        costEstimatingCost: undefined,

        repairsContractorName: undefined,
        repairsContractNumber: undefined,
        repairsContractDate: undefined,
        repairsCost: undefined,
        repairsPeriod: undefined,
        ventilationRepairTypeId: undefined,
        ventilationRepairedSystemsCount: undefined,
        note: values.note,
      };
    },
    handleUpdateVentilation() {
      this.$apollo.mutate({
        mutation: require('@/graphql/updateVentilationShort.gql'),
        skip() {
          return !this.ventilationId || !this.municipality;
        },
        variables: {
          ventilationId: this.ventilationId,
          ventilationData: {
            // TODO: добавить проверку на NaN
            systemType: Number(this.values.systemType) || undefined,
            houseChimneysCount: Number(this.values.houseChimneysCount) || undefined,
            houseChimneysLength: Number(this.values.houseChimneysLength) || undefined,
            houseVentilationChannelsCount: Number(this.values.houseVentilationChannelsCount) || undefined,
            houseVentilationChannelsLength: Number(this.values.houseVentilationChannelsLength) || undefined,
            houseBuildYear: Number(this.values.houseBuildYear),
            houseSquare: Number(this.values.houseSquare),
            houseFloors: Number(this.values.houseFloors),
            houseEntrances: Number(this.values.houseEntrances),
            houseFlats: Number(this.values.houseFlats),
            house20cFormDate: moment(this.values.house20cFormDate).isValid() ? moment(this.values.house20cFormDate).toISOString() : undefined,
            house20cFormConclusion: this.values.house20cFormConclusion,
            house20cFormShutdownReason: this.values.house20cFormShutdownReason,
            houseGasShutdownDate: moment(this.values.houseGasShutdownDate).isValid() ? moment(this.values.houseGasShutdownDate).toISOString() : undefined,
            houseGasShutdownAffectedFlatsCount: Number(this.values.houseGasShutdownAffectedFlatsCount) || undefined,
            houseGasShutdownResumeDate: moment(this.values.houseGasShutdownResumeDate).isValid() ? moment(this.values.houseGasShutdownResumeDate).toISOString() : undefined,
            houseGasShutdownResumeAffectedFlatsCount: Number(this.values.houseGasShutdownResumeAffectedFlatsCount) || undefined,
            houseDeteriorationPercentage: Number(this.values.houseDeteriorationPercentage) || undefined,
            checkupContractorName: this.values.checkupContractorName,
            checkupContractorContractNumber: this.values.checkupContractorContractNumber,
            checkupContractorContractDate: moment(this.values.checkupContractorContractDate).isValid() ? moment(this.values.checkupContractorContractDate) : undefined,
            checkupResult: this.values.checkupResult,
            costEstimatingContractorName: this.values.costEstimatingContractorName,
            costEstimatingContractNumber: this.values.costEstimatingContractNumber,
            costEstimatingContractDate: moment(this.values.costEstimatingContractDate).isValid() ? moment(this.values.costEstimatingContractDate) : undefined,
            costEstimatingCost: Number(this.values.costEstimatingCost) || undefined,
            repairsContractorName: this.values.repairsContractorName,
            repairsContractNumber: this.values.repairsContractNumber,
            repairsContractDate: moment(this.values.repairsContractDate).isValid() ? moment(this.values.repairsContractDate) : undefined,
            repairsCost: Number(this.values.repairsCost) || undefined,
            ventilationRepairTypeId: this.values.ventilationRepairTypeId || undefined,
            ventilationRepairedSystemsCount: Number(this.values.ventilationRepairedSystemsCount) || undefined,
            note: this.values.note || undefined,
          }
        },
      }).then((response) => {
        this.setValues(response?.data?.updateVentilationFull || {});
      }).catch((error) => {
        console.error('error', error);
      });
    },
  }
};
</script>

<style module>
.title {
  margin-bottom: 40px;
  font-weight: 400;
  font-size: 18px;
  line-height: 21px;
  text-align: center;
  color: var(--v-ventilationTitle-base);
}

.inputButton {
  min-width: 210px;
}
</style>
